{ 砥-ࠢ ࠧ ᪠ }
{ $define debug}
{$define v140}
{ $define v800}
const
  p1 = $3BC; p2 = $378; p3 = $278;
  p = p2;	{  ࠫ쭮  }

  io_Data	: Byte = $00; { 砫 祭 ⮢ }
  io_Status	: Byte = $FF;
  io_Ctrl	: Byte = $00;

  state		: String = '';

  param		: String = '';

  AcRead	: Byte = 2;
  AcWrite	: Byte = 4;
  AcChange	: Byte = 6;

  {$ifdef v140}
    ntrack	= 35;
    nsector	= 16;
  {$endif}
  {$ifdef v800}
    ntrack	= 160;
    nsector	= 21;
  {$endif}

type
  tSect		= Array[0..255] of Byte;
  tTrack	= Array[0..nsector-1] of tSect;

{ -뢮 / ⮢ }
procedure port_get;
begin
{  ioctl(fdPPI, PPIGDATA,   &io_Data); }
  io_Status := port[p+1];
{  ioctl(fdPPI, PPIGCTRL,   &io_Ctrl); }
  {$ifdef debuf}
    writeln('in ', io_Status, '[', state, ']');
  {$endif}
end;

procedure port_set;
begin
  port[p+0] := io_Data;
{  ioctl(fdPPI, PPISSTATUS, &io_Status); }
  port[p+2] := io_Ctrl;
  {$ifdef debuf}
    writeln('out ', io_Data, ' ', io_Ctrl, '[', state, ']');
  {$endif}
end;


{
	PC		AGAT
Data D7..D4	->	2 D6..D3
Status D6..D3	<-	0 D7..D4
Ctrl D0		=>inv	2 D7
Status D7	<=inv	1 D7
}


{ ࠢ 㡠 tm  砥 㡠 rc }
procedure io_05byte(const tm: Byte; var rc: Byte);
begin
  state := '05  A';
  repeat port_get until (io_Status and $80) <> 0; { ,    "0"  䨧᪮ ࠫ }
  io_Data := tm shl 4; port_set;		  { ࠢ 㡠 }
  rc := (io_Status shr 3) and $0F;		  { 뢠 㡠 }
  io_Ctrl := io_Ctrl or $01; port_set;		  { ࠢ "0"  䨧 ࠫ }
  state := '05  B';
  repeat port_get until (io_Status and $80) = 0;  { ,    "1"  䨧᪮ ࠫ }
  io_Ctrl := io_Ctrl and $FE; port_set;		  { ࠢ "1"  䨧 ࠫ }
  {$ifdef debug}
    writeln(tm, ' -> , ', rc, ' <-');
  {$endif}
end;


{ ࠢ  tm  砥  rc }
procedure io_byte(const tm: Byte; var rc: Byte);
var l, h: Byte;
begin
  io_05byte(tm and $0F, l);
  io_05byte(tm shr   4, h);

  rc := (h shl 4) or l;
end;


{ ࠢ  . ਭ  뢠 }
procedure send_byte(const v: Byte);
var t: Byte; begin io_byte(v, t) end;


{ 砥  ᭠㦨. ࠢ  0xFF }
function recv_byte: Byte;
var t: Byte; begin io_byte($FF, t); recv_byte := t end;


{  稥    
  頥 False, ᫨   ("1"  䨧᪮ ࠫ) }
function data_present: Boolean;
begin port_get; data_present := (io_Status and $80) <> 0 end;


{ ஭ ⮪ }
procedure syncer;
label loop, sync;
var p: Byte;
begin
  write('Sync... ');

loop:
  io_05byte($7, p); if p <> $6 then goto sync;
  io_05byte($5, p); if p <> $4 then goto sync;
  io_05byte($3, p); if p <> $2 then goto sync;
  io_05byte($1, p); if p <> $0 then goto sync;

  writeln('Ok.');
  exit;

sync:
  write('Fault. Wait for Enter...');
  readln;
  write('Repeat sync... ');
  goto loop;
end;


{ ᥪ ࠧ ४ }
procedure reverse(var buf: tTrack);
var tmp: tTrack; sc: Byte;
begin
  for sc := low(buf) to high(buf) do tmp[high(buf)-sc] := buf[sc];
  buf := tmp;
end;


{ ࠢ   㦨
  ࠢ ⢥ -  0x45,  ᨭ஭ }
procedure ctrl_out(const action, tr, nsc: Byte);
var d: Byte;
begin
  repeat
    syncer;
    write(': ');
    if (action and $FE) = (AcRead and $FE) then write('') else write('');
    write(', tr=', tr, ', nsc=', nsector-1, '... ');
    send_byte(action);
    send_byte(tr);
    send_byte(nsc);
    send_byte(action xor tr xor nsc);
    d := recv_byte;
    writeln('CTRL_OUT: ', d);
  until d = $45;
end;


{ ࠢ ४ }
procedure transmite_track(const tr: Byte; var buf: tTrack);
var crc, s, b, fillcnt, errcnt: Byte; diff, eflag: Boolean;
begin
  repeat
    errcnt := 0; fillcnt := 0;
    ctrl_out(AcWrite, tr, nsector-1);

    for s := 0 to nsector-1 do begin
      diff := False;
      for b := 1 to 255 do if buf[s][b] <> buf[s][0] then begin diff := True; break; end;
      if diff then begin
        send_byte($83);
	crc := 0;
	for b := 0 to 255 do begin
	  send_byte(buf[s][b]);
	  crc := crc xor buf[s][b];
	end;
	eflag := (crc <> recv_byte);
	inc(fillcnt);
      end else begin
        send_byte($27);
	send_byte(buf[s][0]);
	eflag := (recv_byte <> not buf[s][0]);
      end;
      if eflag then begin write('e'); inc(errcnt); end else write('.');
    end;

    writeln('... ', errcnt, ' error(s), ', fillcnt, '/', nsector, ' fill sectors.');
  until errcnt = 0;
end;


{  ४ }
procedure receive_track(const tr: Byte; var buf: tTrack);
label retrace;
var crc, s, b, fillcnt, errcnt: Byte; diff, eflag: Boolean;
begin
  repeat
retrace:
    errcnt := 0; fillcnt := 0;
    ctrl_out(AcRead, tr, nsector-1);

    for s := 0 to nsector-1 do begin
      case recv_byte of
      $27: begin
        crc := recv_byte;
	fillchar(buf[s], 256, crc);
	eflag := (crc <> not recv_byte);
      end;
      $83: begin
        crc := 0;
	for b := 0 to 255 do begin
	  buf[s][b] := recv_byte;
	  crc := crc xor buf[s][b];
	end;
	eflag := (crc <> recv_byte);
	inc(fillcnt);
      end;
      else goto retrace;
      end;
      if eflag then begin write('e'); inc(errcnt); end else write('.');
    end;

    writeln('... ', errcnt, ' error(s), ', fillcnt, '/', nsector, ' fill sectors.');
  until errcnt = 0;
end;


{ ࠢ ࠧ }
procedure transmite_image(const fn: String);
var f: file of tTrack; t: Byte; buf: tTrack;
begin
  FileMode := 0;
  assign(f, fn); reset(f);
  for t := 0 to ntrack-1 do begin
    read(f, buf);
    reverse(buf);
    transmite_track(t, buf);
  end;
  close(f);
end;


{  ࠧ }
procedure receive_image(const fn: String);
var f: file of tTrack; t: Byte; buf: tTrack;
begin
  FileMode := 1;
  assign(f, fn); rewrite(f);
  for t := 0 to ntrack-1 do begin
    receive_track(t, buf);
    reverse(buf);
    write(f, buf);
  end;
  close(f);
end;


{  ⥪饣 ਢ   }
procedure drive_change(const sd: String);
var s, d: Byte; i: Integer;
begin
  val(sd, s, i);
  if i = 0 then begin
    d := (s mod 10) and 1;
    s := s div 10;
    if not s in [1..6] then s := 5;
    ctrl_out(AcChange, s, d); 
    writeln('Change drive to ', s, '/', d);
  end;
end;


begin
  port[p+1] := io_Status;
  port[p+2] := io_Ctrl;

  if paramcount > 1 then begin
    param := paramstr(1);
    if Length(param) > 1 then
      if param[2] = 'F' then begin AcRead := 3; AcWrite := 5 end;
    if param[1] = 'r' then receive_image(paramstr(2));
    if param[1] = 't' then transmite_image(paramstr(2));
    if param[1] = 'd' then drive_change(paramstr(2));
  end else begin
    writeln('USAGE: m_d_v {{r|t} IMAGE.DSK} | {d SD}');
  end;
end.
